﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Drawing;
using MindFusion.Diagramming;
using MindFusion.Diagramming.Mvc;
using MindFusion.Diagramming.Layout;
using SolidBrush = MindFusion.Drawing.SolidBrush;
using LinearGradientBrush = MindFusion.Drawing.LinearGradientBrush;

namespace Tutorial2.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewBag.Message = "Modify this template to jump-start your ASP.NET MVC application.";

            return View();
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your app description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }

        public JsonResult Test(string json, string index)
        {
            DiagramView view = DiagramView.FromJson(json);
            Diagram diagram = view.Diagram;
            var newNode = ((ShapeNode)diagram.Nodes[Int32.Parse(index)]);
            newNode.Text = "node " + (diagram.Nodes.Count - 1).ToString();
            if (diagram.Nodes.Count > 1)
            {
                // create a link between the root node and the newly created node and apply the layout to the diagram
                var link = diagram.Factory.CreateDiagramLink(diagram.Nodes[0], newNode);
                var layout = new FractalLayout();
                layout.Root = diagram.Nodes[0];
                layout.Arrange(diagram);
            }
            else
            {
                // set the newly created node as a root node
                newNode.Brush = new SolidBrush(Color.DarkRed);
                ((ShapeNode)newNode).Text = "Root";
            }
            return Json(new { success = DiagramView.ToJson(view) });
        }
    }
}